Controllers/ListaEsperaController.cs
using MySql.Data.MySqlClient;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Mail;
using System.Net.Security;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using System.Web;
using System.Web.Mvc;
using WebFBX.Clases;
using WebFBX.Models;

namespace WebFBX.Controllers
{
    public class ListaEsperaController : Controller
    {
        Clase_Conexion conexion = new Clase_Conexion();

        [HttpPost]
        public ActionResult EnviarEmailUsuario(string codigo, string nombrecliente, string correocliente, string telefono,string nombreproducto)
        {
            string retorno = "0";
            try
            {
                conexion.conectar();
                //String ts = "start transaction";
                //MySqlCommand datos_ts = new MySqlCommand(ts, conexion.con);
                //datos_ts.ExecuteScalar();


                String sql;

                sql = "UPDATE productos ";
                sql += "SET agotado = @agotado ";
                sql += "WHERE codigo = @codigo ";


                MySqlCommand datos = new MySqlCommand(sql, conexion.con);
                datos.Parameters.Add(new MySqlParameter("@agotado", "0"));
                datos.Parameters.Add(new MySqlParameter("@codigo", codigo));
                datos.ExecuteNonQuery();


                string emailenvio = Session["ss_email"].ToString();
                string passwordenvio = Session["ss_password"].ToString();
                string host = Session["ss_smtp"].ToString();

                int puerto = Convert.ToInt32(Session["ss_puerto"]);

                SmtpClient client = new SmtpClient
                {
                    Host = host,
                    Port = puerto,
                    EnableSsl = true,
                    Timeout = 10000,
                    DeliveryMethod = SmtpDeliveryMethod.Network,
                    UseDefaultCredentials = false,
                    Credentials = new NetworkCredential(emailenvio, passwordenvio)
                };
                string titulo_subjet = "";

                string body = "";

                titulo_subjet = "Aviso de producto disponible";
                body = "<p>Estimado(a) " + nombrecliente + "</p>";
                body = body + "<p>Le informamos que el producto " + nombreproducto + " ya se encuentra disponible</p>";
                body = body + "Atte.<br/>FISH BOX<br/>";

                MailMessage mail = new MailMessage
                {
                    From = new MailAddress(emailenvio),
                    BodyEncoding = Encoding.UTF8,
                    IsBodyHtml = true,
                    Priority = MailPriority.Normal,
                    DeliveryNotificationOptions = DeliveryNotificationOptions.OnFailure,
                    Subject = titulo_subjet,
                    Body = body,
                };

                mail.To.Add(new MailAddress(correocliente));

                //foreach (var c in copia)
                //{
                //    mail.CC.Add(new MailAddress(c));
                //}

                ServicePointManager.ServerCertificateValidationCallback =
                    delegate (object s
                        , X509Certificate certificate
                        , X509Chain chain
                        , SslPolicyErrors sslPolicyErrors)
                    { return true; };

                client.Send(mail);

                sql = "UPDATE listaespera ";
                sql += "SET enviado = @enviado ";
                sql += "WHERE telefono = @telefono ";

                MySqlCommand datos_esp = new MySqlCommand(sql, conexion.con);
                datos_esp.Parameters.AddWithValue("@telefono", telefono);
                datos_esp.Parameters.AddWithValue("@enviado", 1);
                datos_esp.ExecuteNonQuery();


                //String commit = "commit";
                //MySqlCommand datos_commit = new MySqlCommand(commit, conexion.con);
                //datos_commit.ExecuteScalar();

                retorno = "1";
            }
            catch (Exception error)
            {
                //String rollback = "rollback";
                //MySqlCommand datos_rollback = new MySqlCommand(rollback, conexion.con);
                //datos_rollback.ExecuteScalar();

                retorno = error.Message;
            }
            finally
            {
                conexion.cerrar();
            }
            return Json(retorno);
        }

        public ActionResult partialListadoClientesEspera(string codigopro, string nombreproducto, int agotado)
        {

            List<ClientesEsperaModels> ListaClientes = new List<ClientesEsperaModels>();

            int retorno = 0;
            string mensaje_error = "";
            string fecha = "";
            string telefono = "";
            string correo = "";
            string clientes = "";
            try
            {
                String sql;
                ViewData["codigopro"] = codigopro;
                ViewData["nombreproducto"] = nombreproducto;
                if (agotado == 1)
                {
                    ViewData["agotado"] = "Agotado: Sí";
                }
                else
                {
                    ViewData["agotado"] = "Agotado: No";
                }

                int cant_usuarios = 0;

                sql = " SELECT listado.nombrecliente,listado.telefono, DATE_FORMAT(listado.fecha,'%d/%m/%Y') AS fecha,listado.correo FROM";
                sql += " (SELECT l.nombrecliente,l.telefono,l.fecha,correo FROM listaespera l WHERE l.enviado=0 AND l.producto=@producto ORDER BY fecha DESC) listado GROUP BY listado.telefono";
                conexion.conectar();
                using (MySqlCommand cmd = new MySqlCommand(sql, conexion.con))
                {
                    cmd.Parameters.AddWithValue("@producto", codigopro);

                    using (MySqlDataReader d = cmd.ExecuteReader())
                    {
                        while (d.Read())
                        {
                            cant_usuarios++;
                            clientes = d["nombrecliente"].ToString();
                            telefono = d["telefono"].ToString();
                            fecha = d["fecha"].ToString();
                            correo = d["correo"].ToString();


                            ListaClientes.Add(new ClientesEsperaModels
                            {
                                nombre = clientes,
                                telefono = telefono,
                                fecha = fecha,
                                email = correo,
                                codigopro = codigopro,
                                nombreproducto = nombreproducto
                            });

                        }
                    }
                }
                ViewData["cant_usuarios"] = "N° Usuarios:" + cant_usuarios.ToString();

                retorno = 1;
                return View(ListaClientes);
            }
            catch (Exception error)
            {
                retorno = -1;
                mensaje_error = error.Message.ToString();
                return Json(new { retornoJson = retorno, mensajeJson = mensaje_error });
            }
            finally
            {
                conexion.cerrar();
            }
        }

        [HttpPost]
        public ActionResult EnviarEmailUsuariosEnEspera(string codigo, string indicador)
        {
            string retorno = "0";
            try
            {
                List<string> coreosLista = new List<string>();
                conexion.conectar();
                int existe_espera = 0;
                //String ts = "start transaction";
                //MySqlCommand datos_ts = new MySqlCommand(ts, conexion.con);
                //datos_ts.ExecuteScalar();


                String sql;

                sql = "UPDATE productos ";
                sql += "SET agotado = @agotado ";
                sql += "WHERE codigo = @codigo ";


                MySqlCommand datos = new MySqlCommand(sql, conexion.con);
                datos.Parameters.Add(new MySqlParameter("@agotado", "0"));
                datos.Parameters.Add(new MySqlParameter("@codigo", codigo));
                datos.ExecuteNonQuery();

                //if (indicador == "0")
                //{



                sql = "SELECT correo,nombreproducto ";
                sql += "FROM listaespera WHERE producto=@producto AND enviado=@enviado GROUP BY telefono";

                string correo = "";
                string nombreproducto = "";

                using (MySqlCommand cmd = new MySqlCommand(sql, conexion.con))
                {
                    cmd.Parameters.AddWithValue("@producto", codigo);
                    cmd.Parameters.AddWithValue("@enviado", "0");

                    using (MySqlDataReader d = cmd.ExecuteReader())
                    {
                        while (d.Read())
                        {
                            existe_espera = 1;
                            correo = d["correo"].ToString();
                            nombreproducto = d["nombreproducto"].ToString();

                            coreosLista.Add(correo);

                        }
                    }
                }

                if (existe_espera == 1)
                {
                    string[] correosArray = coreosLista.ToArray();
                    string correosJoin = string.Join(";", correosArray);
                    string emailenvio = Session["ss_email"].ToString();
                    string passwordenvio = Session["ss_password"].ToString();
                    string host = Session["ss_smtp"].ToString();

                    int puerto = Convert.ToInt32(Session["ss_puerto"]);

                    SmtpClient client = new SmtpClient
                    {
                        Host = host,
                        Port = puerto,

Views/ListaEspera/VerListaEspera.cshtml
@{
    ViewBag.Title = "Lista Espera";
    Layout = "~/Views/Shared/_Layout_Admin.cshtml";

}
<br />
<div class="container">
    <div class="row">
        <div class="col-lg-12">
            <h3 class="page-header-azuloscuro top_tituloencabezado">
                @ViewBag.Title
            </h3>

        </div>
    </div>
    <div class="row">
        <div class="col-lg-12">
            <div style="color:red;font-weight:bold">
                AL ENVÍAR CORREO A LOS CLIENTES, EL ESTADO AGOTADO DEL PRODUCTO CAMBIA A NO AGOTADO
            </div>
        </div>
    </div>
    <div class="row">
        <div class="col-lg-12">
            <div id="ListaParcial_ListaEspera">
            </div>
        </div>
    </div>

</div>

@section scripts{
    <script>
        var table_productos = "";
        var listado_table_fotos = "";
        var getBrowserWidth = function () {
            if (window.innerWidth < 768) {
                // Extra Small Device
                return "xs";
            } else if (window.innerWidth < 991) {
                // Small Device
                return "sm"
            } else if (window.innerWidth < 1199) {
                // Medium Device
                return "md"
            } else {
                // Large Device
                return "lg"
            }
        };
        function listado_productosespera() {
            $("#ajax_loader_2").css("display", "");
            var url_action = '@Html.Raw(Url.Action("partialListadoProductoEspera", "ListaEspera"))';
                $.ajax({
                contentType: false,
                processData: false,
                type: 'POST',
                url: url_action,
                success: function (result) {
                    $("#ajax_loader_2").css("display", "none");
                    if (result.retornoJson == -1) {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + result.mensajeJson);
                    }
                    else {
                        $("#ListaParcial_ListaEspera").html(result);
                    }
                }
            });
        }
        function listado_clienteespera(codigopro, nombreproducto, agotado) {
            $("#ajax_loader_2").css("display", "");
            var url_action = '@Html.Raw(Url.Action("partialListadoClientesEspera", "ListaEspera", new { codigopro = "codigopro_", nombreproducto = "nombreproducto_", agotado = "agotado_" }))';
            url_action = url_action.replace("codigopro_", codigopro).replace("nombreproducto_", nombreproducto).replace("agotado_", agotado);

                $.ajax({
                contentType: false,
                processData: false,
                type: 'POST',
                url: url_action,
                success: function (result) {
                    $("#ajax_loader_2").css("display", "none");
                    if (result.retornoJson == -1) {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + result.mensajeJson);
                    }
                    else {
                        $("#ListaParcial_ListaEspera").html(result);
                    }
                }
            });
         }
        $(document).ready(function () {

            listado_productosespera();
        });

    </script>
    @Scripts.Render("~/bundles/fotoProducto")

}

Views/ListaEspera/partialListadoClientesEspera.cshtml
@model IEnumerable<WebFBX.Models.ClientesEsperaModels>

@{
    Layout = null;
    int i = 0;
    string codigoproducto = ViewData["codigopro"].ToString();
}

<br />
<div class="row">
    <div class="col-lg-2" style="max-width:130px">
        <img src="@Url.Action("GetFoto","ListaEspera",new { codigo=codigoproducto})" alt="" class="img-fluid" style="max-width:120px;" />
    </div>
    <div class="col-lg-10">
        <div class="row">
            <div class="col-lg-12">
                <u>@ViewData["nombreproducto"]</u>
            </div>
        </div>
        <div class="row">
            <div class="col-lg-12">
                @ViewData["agotado"]
            </div>
        </div>
        <div class="row">
            <div class="col-lg-12">
                @ViewData["cant_usuarios"]
            </div>
        </div>
    </div>
</div>

<br />
<table id="table_clientes" class="table-striped table-bordered tableSection table_consulta cursor_table" cellspacing="0" width="100%" data-role="datatable">
    <thead>
        <tr>
            <th>
                Nombre
            </th>
            <th>
                Teléfono
            </th>
            <th>
                Fecha
            </th>
            <th>
                Email
            </th>
            <th>
                Acciones
            </th>

        </tr>
    </thead>
    <tbody>

        @foreach (var item in Model)
        {
            i++;
            <tr>

                <td>
                    @item.nombre
                </td>
                <td>
                    @item.telefono
                </td>
                <td>
                    @item.fecha
                </td>
                <td>
                    @item.email
                </td>
                <td class="text-center acciones">
                    <button type="button" id="enviaremail_@i" class="btn btn-success btn-sm enviar_email_cliente" data-nombreproducto="@item.nombreproducto" data-telefono="@item.telefono" data-cliente="@item.nombre" data-correo="@item.email" data-codigo="@item.codigopro" data-fila="@i" data-nombre="@item.nombreproducto" title="Enviar email al cliente">
                        <span class="fas fa-envelope"></span> Enviar
                    </button>
                </td>

            </tr>
        }
    </tbody>
</table>

<script type="text/javascript" class="init">

    $(document).ready(function () {
        table_clientes = $('#table_clientes').DataTable({
            destroy: true,
            "bInfo": true,
            "bPaginate": true,
            "searching": true,
            "bSort": false,
            "scrollX": true,
            //"autoWidth": false,
            //"scrollX": "100%",
            //"scrollXInner": "110%",
            //"scrollCollapse": true,
            //"autoWidth": false,
            dom: 'Bfrtip',
            buttons: [
                {
                    text: '<i class="fas fa-chevron-left"></i> Atras',
                    action: function (e, dt, node, config) {
                        listado_productosespera();
                    }

                },
                'copy', 'csv', 'excel', 'pdf', 'print',
                
            ],

            "columns": [
                { "width": "40%" },
                { "width": "20%" },
                { "width": "10%" },
                { "width": "20%" },
                { "width": "10%" },
            ],
            "lengthMenu": [[10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285], [10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285]],
            "language": {
                "sProcessing": "Procesando...",
                "sLengthMenu": "Mostrar _MENU_ registros",
                "sZeroRecords": "No se encontraron resultados",
                "sEmptyTable": "Ningún dato disponible en esta tabla",
                "sInfo": "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                "sInfoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                "sInfoPostFix": "",
                "sSearch": "Buscar:",
                "sUrl": "",
                "sInfoThousands": ",",
                "sLoadingRecords": "Cargando...",
                "oAria": {
                    "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                },
                "paginate": {
                    "previous": "Anterior",
                    "next": "Siguiente"
                },
                "buttons": {
                    copy: 'copiar',
                    print: 'impimir'

                }
            },
            fixedHeader: {
                header: true,
                footer: true
            },

        });
        $(".dt-button").addClass("btn btn-sm");
        $(".dt-button").addClass("padding_5_datatable");
        var device = getBrowserWidth();
        if (device === "xs") {
            $(".acciones").addClass("form-inline");
            $(".enviar_email").html('<span class="fas fa-envelope"></span>');
            $(".verusuario").html(' <span class="fas fa-user"></span>');

        } else {
        }


        $('#table_clientes tbody').on('click', '.enviar_email_cliente', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var cliente = $(this).data('cliente');
            var correo = $(this).data('correo');
            var telefono = $(this).data('telefono');
            var nombreproducto = $(this).data('nombreproducto');

            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("nombrecliente", cliente);
            fd.append("correocliente", correo);
            fd.append("telefono", telefono);
            fd.append("nombreproducto", nombreproducto);


            $.ajax({
                type: "POST",
                url: '/ListaEspera/EnviarEmailUsuario/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        $("#modal_exito").modal("show");
                        $("#exito_modal_msj").html('Correo enviado exitosamente');
                        listado_productosespera();
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });

    });
</script>

Views/ListaEspera/partialListadoProductoEspera.cshtml
@model IEnumerable<WebFBX.Models.ProductosEsperaModels>

@{
    Layout = null;
    int i = 0;
}

<table id="table_productos" class="table-striped table-bordered tableSection table_consulta cursor_table" cellspacing="0" width="100%" data-role="datatable">
    <thead>
        <tr>

            <th>
                Código
            </th>
            <th>
                Producto
            </th>
            <th class="text-center">
                Agotado
            </th>
            <th>
                Usuarios
            </th>
            <th class="text-center">
                Acciones
            </th>

        </tr>
    </thead>
    <tbody>

        @foreach (var item in Model)
        {
            i++;
            <tr>

                <td>
                    <img src="@Url.Action("GetFoto","ListaEspera",new { codigo=item.codigo})" alt="" class="img-fluid" style="max-width:50px;" />
                    @Html.DisplayFor(modelItem => item.codigo)
                </td>
                <td>
                    @item.nombre
                </td>

                <td class="text-center">
                    @if (item.agotado == 0)
                    {
                        <text>No</text>
                        @*<input type="checkbox" id="agotado_@i" class="text_dt_input_select agotado" data-fila="@i" data-codigo="@item.codigo" disabled/>*@
                    }
                    else
                    {
                        <text>Si</text>
                        @*<input type="checkbox" id="agotado_@i" class="color_text_dt_input_select agotado" data-fila="@i" data-codigo="@item.codigo" checked disabled />*@
                    }
                </td>
                <td>
                    @item.clientes
                </td>
                <td class="text-center acciones">
                    <button type="button" id="enviaremail_@i" class="btn btn-success btn-sm enviar_email" data-codigo="@item.codigo" data-fila="@i" data-nombre="@item.nombre" title="Enviar email a los clientes">
                        <span class="fas fa-envelope"></span>Enviar 
                    </button>
                    <button type="button" id="verusuario_@i" class="btn btn-info btn-sm verusuario" data-codigo="@item.codigo" data-fila="@i" data-nombre="@item.nombre" data-agotado="@item.agotado" title="Ver usuario cliente">
                        <span class="fas fa-user"></span>Usuario
                    </button>
                </td>

            </tr>
        }
    </tbody>
</table>

<script type="text/javascript" class="init">

    $(document).ready(function () {
        table_productos = $('#table_productos').DataTable({
            destroy: true,
            "bInfo": true,
            "bPaginate": true,
            "searching": true,
            "bSort": false,
            "scrollX": true,
            //"autoWidth": false,
            //"scrollX": "100%",
            //"scrollXInner": "110%",
            //"scrollCollapse": true,
            //"autoWidth": false,
            dom: 'Bfrtip',
            buttons: [
                'copy', 'csv', 'excel', 'pdf', 'print'
            ],
            
            "columns": [
                { "width": "10%" },
                { "width": "55%" },
                { "width": "10%" },
                { "width": "10%" },
                { "width": "15%" },
            ],
            "lengthMenu": [[10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285], [10, 15, 45, 75, 105, 135, 165, 195, 225, 255, 285]],
            "language": {
                "sProcessing": "Procesando...",
                "sLengthMenu": "Mostrar _MENU_ registros",
                "sZeroRecords": "No se encontraron resultados",
                "sEmptyTable": "Ningún dato disponible en esta tabla",
                "sInfo": "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                "sInfoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
                "sInfoFiltered": "(filtrado de un total de _MAX_ registros)",
                "sInfoPostFix": "",
                "sSearch": "Buscar:",
                "sUrl": "",
                "sInfoThousands": ",",
                "sLoadingRecords": "Cargando...",
                "oAria": {
                    "sSortAscending": ": Activar para ordenar la columna de manera ascendente",
                    "sSortDescending": ": Activar para ordenar la columna de manera descendente"
                },
                "paginate": {
                    "previous": "Anterior",
                    "next": "Siguiente"
                },
                "buttons": {
                    copy: 'copiar',
                    print:'impimir'

                }
            },
            fixedHeader: {
                header: true,
                footer: true
            },

        });
        $(".dt-button").addClass("btn btn-sm");
        $(".dt-button").addClass("padding_5_datatable");

        var device = getBrowserWidth();
        if (device === "xs") {
            $(".acciones").addClass("form-inline");
            $(".enviar_email").html('<span class="fas fa-envelope"></span>');
            $(".verusuario").html(' <span class="fas fa-user"></span>');
        } else {
        }

        $('#table_productos tbody').on('click', '.verusuario', function (e) {
            //e.preventDefault();
            var codigopro = $(this).data('codigo');
            var nombreproducto = $(this).data('nombre');
            var agotado = $(this).data('agotado');            
            listado_clienteespera(codigopro, nombreproducto, agotado)
           
        });

        $('#table_productos tbody').on('click', '.enviar_email', function (e) {
            //e.preventDefault();
            var codigo = $(this).data('codigo');
            var indicador = 0;
            if ($(this).prop('checked')) {
                indicador = 1;
            }
            var fd = new FormData();
            fd.append("codigo", codigo);
            fd.append("indicador", indicador);

            $.ajax({
                type: "POST",
                url: '/ListaEspera/EnviarEmailUsuariosEnEspera/',
                data: fd,
                contentType: false,
                processData: false,
                DataType: 'json',
                success: function (data) {
                    if (data == "1") {
                        $("#modal_exito").modal("show");
                        $("#exito_modal_msj").html('Correos enviado exitosamente');
                        listado_productosespera();
                    }
                    else {
                        $("#modal_error").modal("show");
                        $("#error_modal_msj").html("Error interno:" + data);
                    }
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    $("#modal_error").modal("show");
                    $("#error_modal_msj").html("Error de conexion al guardar cliente: " + errorThrown);
                }
            });
        });

    });
</script>